/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: complex_lock_dataPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the complex_lock_dataPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=complex_lock_data.class)
public class complex_lock_dataPointer extends StructurePointer {

	// NULL
	public static final complex_lock_dataPointer NULL = new complex_lock_dataPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected complex_lock_dataPointer(long address) {
		super(address);
	}

	public static complex_lock_dataPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static complex_lock_dataPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static complex_lock_dataPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new complex_lock_dataPointer(address);
	}

	public complex_lock_dataPointer add(long count) {
		return complex_lock_dataPointer.cast(address + (complex_lock_data.SIZEOF * count));
	}

	public complex_lock_dataPointer add(Scalar count) {
		return add(count.longValue());
	}

	public complex_lock_dataPointer addOffset(long offset) {
		return complex_lock_dataPointer.cast(address + offset);
	}

	public complex_lock_dataPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public complex_lock_dataPointer sub(long count) {
		return complex_lock_dataPointer.cast(address - (complex_lock_data.SIZEOF * count));
	}

	public complex_lock_dataPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public complex_lock_dataPointer subOffset(long offset) {
		return complex_lock_dataPointer.cast(address - offset);
	}

	public complex_lock_dataPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public complex_lock_dataPointer untag(long mask) {
		return complex_lock_dataPointer.cast(address & ~mask);
	}

	public complex_lock_dataPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return complex_lock_data.SIZEOF;
	}

	// Implementation methods

	// I16 flags
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_flagsOffset_", declaredType="I16")
	public I16 flags() throws CorruptDataException {
		return new I16(getShortAtOffset(complex_lock_data._flagsOffset_));
	}

	// I16 flags
	public I16Pointer flagsEA() throws CorruptDataException {
		return I16Pointer.cast(nonNullFieldEA(complex_lock_data._flagsOffset_));
	}

	// I16 recursion_depth
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_recursion_depthOffset_", declaredType="I16")
	public I16 recursion_depth() throws CorruptDataException {
		return new I16(getShortAtOffset(complex_lock_data._recursion_depthOffset_));
	}

	// I16 recursion_depth
	public I16Pointer recursion_depthEA() throws CorruptDataException {
		return I16Pointer.cast(nonNullFieldEA(complex_lock_data._recursion_depthOffset_));
	}

	// uint_t reserved
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_reservedOffset_", declaredType="uint_t")
	public UDATA reserved() throws CorruptDataException {
		return new U32(getIntAtOffset(complex_lock_data._reservedOffset_));
	}

	// uint_t reserved
	public UDATAPointer reservedEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(complex_lock_data._reservedOffset_));
	}

	// complex_lock_status status
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_statusOffset_", declaredType="complex_lock_status")
	public IDATA status() throws CorruptDataException {
		return new I32(getIntAtOffset(complex_lock_data._statusOffset_));
	}

	// complex_lock_status status
	public IDATAPointer statusEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(complex_lock_data._statusOffset_));
	}

}
